using UnityEngine;

public class PlaneGenerator : ShapeGenerator
{
    #region InspectorVariables
    [Header("Plane values")]
    [SerializeField]
    protected Vector3[] _vertices;
    public Vector3[] Vertices
    {
        get => _vertices.Clone() as Vector3[];
        set
        {
            _vertices = value;
            GenerateShapeForAll();
        }
    }
    #endregion InspectorVariables

    #region Implementation
    protected override (Vector3[] vertices, int[] triangles) GenerateTopology()
        => CreatePlane(_vertices);
    #endregion Implementation
}