
public static class ArrayExtensions
{
    public static T[] ShallowCloneAppend<T>(this T[] source, T[] append, bool front = false)
    {
        T[] ret = new T[source.Length + append.Length];
        source.CopyTo(ret, front ? append.Length : 0);
        append.CopyTo(ret, front ? 0 : source.Length);
        return ret;
    }

    public static T[] ShallowCloneAppendNullChecked<T>(this T[] source, T[] append, bool front = false)
    {
        if (source == null && append == null)
            return new T[0];

        if (source == null)
            return append.Clone() as T[];

        if (append == null)
            return source.Clone() as T[];
            
        return ShallowCloneAppend<T>(source, append, front);
    }
}
