using System.Collections.Generic;

public static class DictionaryExtensions
{
    public static Dictionary<V, K> ReverseKeyVal<K, V>(this IReadOnlyDictionary<K, V> source)
        => source.ReverseKeyValInto(new());

    public static Dictionary<V, K> ReverseKeyValInto<K, V>(this IReadOnlyDictionary<K, V> source, Dictionary<V, K> target)
    {
        foreach (KeyValuePair<K, V> KeyVal in source)
            if (KeyVal.Value != null)
                target.TryAdd(KeyVal.Value, KeyVal.Key);

        return target;
    }

    public static bool TryAddAllFrom<K, V>(this Dictionary<K, V> target, IReadOnlyDictionary<K, V> source)
    {
        bool all_distinct = true;
        foreach (KeyValuePair<K, V> KeyVal in source)
            if (!target.TryAdd(KeyVal.Key, KeyVal.Value)
             && all_distinct)
                all_distinct = target[KeyVal.Key].Equals(KeyVal.Value);

        return all_distinct;
    }
}