using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public static class IEnumeratorExtensions
{
    public static void FastForward(this IEnumerator that)
    {
        while (that.MoveNext())
            if(that.Current is IEnumerator next)
                next.FastForward();
    }

    public static IEnumerator yield_break => _YieldBreak;
    private static IEnumerator _YieldBreak = YieldBreak();
    public static IEnumerator YieldBreak()
    {
        yield break;
    }

    public static IEnumerator<float> ClockForSeconds(float time)
    {
        if (time < 0) 
            yield break;

        for (float current_time = 0; time > current_time; current_time += Time.deltaTime)
            yield return current_time;

        yield return time;
    }
}
